# Developer Notes

This is a work-in-progress implementation. Feedback and contributions are welcome.

### Strictness

The library enforces as many aspects of the public API as it reasonably can before passing data onto the implementation object. For example, the number and type of arguments. This is intended to both keep implementations more stable, easier to write, and conforming.

The library should err on the side of being overly restrictive (at least during initial development) as it is almost always easier to increase flexibility of an API than tighten it at a future date.

The no-op implementation should not be expected to be able to enforce any restrictions that require retention of state (e.g. calling `end()` multiple times on the same `ActiveSpan` object.)

### No-op implementation

A design choice has been made that, for the purposes of integration simplicity, the library is both the common API as well as a no-op implementation. This means that including the library should not require explicit configuration of a no-op implementation backend in order to run without instrumentation.


## F.A.Q.

**Should there be object pooling / reuse for all the ActiveSpan and ActiveSpan implementation objects?**

This optimization may make sense for a future version once the outward facing API is stabilized.

**Can I log spans before initializing the libray?**

Currently, no, as the underlying implementation object that works with this spans is not created until initialization. However, this seems like a useful feature and that may be implemented in a future version.
