# OpenTracing API for JavaScript

This library is a JavaScript implementation of Open Tracing API intended for use both on the server and in the browser.

## Objectives

Distributed tracing and context propagation have become important analysis tools for today's multi-layer distributed systems comprised of numerous micro-services implemented in different languages.  The success of these tools is dependent on pervasive instrumentation of applications and libraries with trace context propagation support.

The OpenTracing project (http://opentracing.github.io) provides a multi-lingual standard for application-level instrumentation that's loosely coupled to any particular downstream tracing or monitoring system. In this way, adding or switching tracing implementations becomes a single-step code change.

## Status

In the current version, the `opentracing` package provides the core API and a default no-op implementation.

A reference implementation and a set of simple examples are planned.

*See [DEV.md](DEV.md) for further development status and notes.*

## Quick Start

Install the package:

```bash
npm install --save opentracing
```

In the JS code, add instrumentation to the operations to be tracked:

```js
// TBD
```

## Concepts

**Trace** is a virtual representation of the path a request takes through the layers and services of a (potentially distributed) system.

**Span** is a representation of any logical unit of work in the system. Spans can be nested and ordered to model parent-child and casual relationships. A Trace is tree of Spans.

## API

TBD.

## Usage Examples

TBD.

## Development

#### Unit tests

To run the unit tests:

```
npm test
```

#### Publish

To publish a new version of the package to NPM:

```
npm publish
```

*See [DEV.md](DEV.md) for additional detail.*
