'use strict';

import ActiveSpan from './active_span';

/**
 *
 */
export default class Tracer {

    /**
     * [constructor description]
     * @return {[type]} [description]
     */
    constructor() {
        this._imp = null;
    }

    // ---------------------------------------------------------------------- //
    // Properties
    // ---------------------------------------------------------------------- //

    /**
     * [guid description]
     * @return {[type]} [description]
     */
    uuid() {
        if (arguments.length  !== 0) {
            throw new Error('Invalid arguments.');
        }

        if (!this._imp) {
            return '';
        }
        return this._imp.uuid();
    }

    // ---------------------------------------------------------------------- //
    // Events
    // ---------------------------------------------------------------------- //

    /**
     * [on description]
     * @return {[type]} [description]
     */
    on() {
        if (!this._imp) {
            return;
        }
        return this._imp.on(...arguments);
    }

    /**
     * [once description]
     * @return {[type]} [description]
     */
    once() {
        if (!this._imp) {
            return;
        }
        return this._imp.once(...arguments);
    }

    /**
     * [removeListener description]
     * @return {[type]} [description]
     */
    removeListener() {
        if (!this._imp) {
            return;
        }
        return this._imp.removeListener(...arguments);
    }

    // ---------------------------------------------------------------------- //
    // Initialization and options
    // ---------------------------------------------------------------------- //

    /**
     * [initialize description]
     * @param  {[type]} opts [description]
     * @return {[type]}      [description]
     */
    initialize(opts) {
        if (arguments.length  !== 1) {
            throw new Error('Invalid arguments.');
        }

        if (!this._imp) {
            return;
        }
        return this._imp.initialize(opts);
    }

    /**
     * [options description]
     * @param  {[type]} opts [description]
     * @return {[type]}      [description]
     */
    options(opts) {
        if (arguments.length  > 1) {
            throw new Error('Invalid arguments.');
        }

        if (!this._imp) {
            if (arguments.length === 0) {
                return {};
            } else {
                return;
            }
        }
        return this._imp.options(...arguments);
    }

    /**
     * [span description]
     * @param  {[type]} operation [description]
     * @return {[type]}           [description]
     */
    span(operation) {
        if (arguments.length  !== 1) {
            throw new Error('Invalid arguments.');
        }
        if (typeof operation !== 'string') {
            throw new Error('operation expected to be a string');
        }

        if (!this._imp) {
            return new ActiveSpan(null);
        }
        return this._imp.span(operation);
    }

    // ---------------------------------------------------------------------- //
    // Reporting
    // ---------------------------------------------------------------------- //

    /**
     * [flush description]
     * @param  {[type]} doneCallback [description]
     * @return {[type]}              [description]
     */
    flush (doneCallback) {
        if (arguments.length > 1) {
            throw new Error('Wrong number of arguments.');
        }
        if (doneCallback === undefined) {
            doneCallback = function() {};
        }
        if (typeof doneCallback !== 'function') {
            throw new Error('Argument must be a function');
        }


        if (!this._imp) {
            return doneCallback(null);
        }
        return this._imp.flush(doneCallback);
    }
}
